#!/bin/sh

##############################################################################
# Configuration
##############################################################################
product="TomTom ONE"
flashdir="/mnt/flash"
sdmnt="/mnt/sdcard"
ttntoolfound=0
ttntool="ttntool"
gprsengineapp="gprscomd"
gprsenginedir="/bin"
coredumpsenable="coredumpsenable.dat"
coredir="coredir"
corepattern="%e.%t"
coresize="unlimited"

##############################################################################
# Stop TomTom Navigator
##############################################################################

cd /mnt/$1/ttMaps/
running=0
while [ "$running" -eq "0" ] ; do
	ps | grep -v grep | grep startttmaps.sh
	running=$?
done

echo "#killall ttn" >ttmaps.log
killall ttn >>ttmaps.log 2>&1

running=0
while [ "$running" -eq "0" ] ; do
	ps | grep -v grep | grep ttn
	running=$?
done

echo "#killall PNDNavigator" >>ttmaps.log
killall PNDNavigator >>ttmaps.log 2>&1

running=0
while [ "$running" -eq "0" ] ; do
	ps | grep -v grep | grep PNDNavigator
	running=$?
done

##############################################################################
# Enable coredump
##############################################################################

if test ! -d /mnt/$1/coredir; then
  mkdir /mnt/$1/coredir
fi
echo "1" > /proc/sys/kernel/core_uses_pid
echo "/mnt/$1/coredir/%e.%t" > /proc/sys/kernel/core_pattern
ulimit -S -c unlimited

##############################################################################
# Launch ttMaps
##############################################################################

cd /mnt/$1/ttMaps/
export PROJ_LIB=/mnt/$1/ttMaps/proj
export GCONV_PATH=/mnt/$1/ttMaps
export LOCPATH=/mnt/$1/ttMaps
/mnt/$1/ttMaps/ttmaps >>ttmaps.log 2>&1

##############################################################################
# Restarting PNDNavigator
##############################################################################

ALSA_CONFIG_PATH=/etc/alsa/alsa.conf

if [ -f /mnt/sdcard/PNDNavigator ]; then
  echo "*** starting \"/mnt/sdcard/PNDNavigator &\"" >>ttmaps.log
  if [ -f /mnt/sdcard/debuglogs ]; then
    echo "*** redirecting kernel output" >>ttmaps.log
    cat /proc/kmsg >> /mnt/sdcard/kernel.log &
    /mnt/sdcard/PNDNavigator >> /mnt/sdcard/PNDNavigator.log 2>&1 &
  else
    /mnt/sdcard/PNDNavigator > /dev/console 2>&1 &
  fi
else
  echo "*** starting \"/bin/ttn &\"" >>ttmaps.log
  /bin/ttn > /dev/console 2>&1 &
fi

echo "*** restart tt processes" >>ttmaps.log

/etc/init.d/rtc stop
running=0
while [ "$running" -eq "0" ] ; do
  ps | grep -v grep | grep rtc
  running=$?
done
/etc/init.d/rtc start

/etc/init.d/launchserver stop
running=0
while [ "$running" -eq "0" ] ; do
  ps | grep -v grep | grep launchserver.a
  running=$?
done
/etc/init.d/launchserver start

echo "*** $0: Done.\n" >>ttmaps.log

